' ========================================================================================
' GdipGetPropertyIdList
' ========================================================================================

' ========================================================================================
' The following example creates an Image object based on a JPEG file. The code calls the
' GdipGetPropertyCount function of that Image object to find out how many properties are
' stored in the image. Then the code calls the GdipGetPropertyIdList function to get a
' list of the property types.
' ========================================================================================

' SED_PBCC
#COMPILE EXE
#DIM ALL
#INCLUDE "GDIPLUS.INC"

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL hStatus AS LONG
   LOCAL token AS DWORD
   LOCAL StartupInput AS GdiplusStartupInput
   LOCAL pImage AS DWORD
   LOCAL strFileName AS STRING
   LOCAL count AS DWORD
   LOCAL i AS LONG
   DIM   propIDs(0) AS DWORD

   ' // Initialize GDI+
   StartupInput.GdiplusVersion = 1
   hStatus = GdiplusStartup(token, StartupInput, BYVAL %NULL)
   IF hStatus THEN
      PRINT "Error initializing GDI+"
      EXIT FUNCTION
   END IF

   strFileName = UCODE$("Shapes.jpg")
   hStatus = GdipLoadImageFromFile(STRPTR(strFileName), pImage)

   hStatus = GdipGetPropertyCount(pImage, count)
   PRINT "Number of properties =" & STR$(count)

   REDIM propIDs(count - 1)
   hStatus = GdipGetPropertyIdList(pImage, count, propIDs(0))
   FOR i = 0 TO count - 1
      PRINT HEX$(propIDs(i))
   NEXT

   ' // Cleanup
   IF pImage THEN GdipDisposeImage(pImage)

   ' // Shutdown GDI+
   GdiplusShutdown token

   WAITKEY$

END FUNCTION
' ========================================================================================
